//=============================================================================
// ESRT_Plugins_override.js
// ----------------------------------------------------------------------------
// Copyright (c) 2016 @white_esorat
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// ----------------------------------------------------------------------------
// [HP]   : https://esora-t.jp/
// [Twitter]: https://twitter.com/white_esorat
//=============================================================================

//=============================================================================
// Copyright (c) 2015 Triacontane
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// ※トリアコンタン様製プラグインの独自修正を行うにあたって、
// 　トリアコンタン様のパラメータ取得用関数を利用させていただいています。
// ----------------------------------------------------------------------------
// [Blog]   : http://triacontane.blogspot.jp/
// [Twitter]: https://twitter.com/triacontane/
// [GitHub] : https://github.com/triacontane/
//=============================================================================

/*:
 * @plugindesc Other Pluguin Override
 * @author white_esorat
 *
 * @param ReplaceRoute
 * @desc （TemplateEvent.jsに機能追加）固有イベントに移動ルートが設定されていた場合でも、無視してテンプレートイベントの移動ルートに置換します。
 * @default OFF
 
 * @param paramFoceReplaceRouteType
 * @desc （TemplateEvent.jsに機能追加）移動ルート置換がOFFのとき、例外的にテンプレートイベントの移動ルートに置換する移動タイプ・移動条件の組み合わせを指定します。
 * @default OFF
 
 * @param paramFoceReplaceRouteSpeed
 * @desc （TemplateEvent.jsに機能追加）固有イベントに移動ルートが設定されていた場合でも、無視してテンプレートイベントの移動ルートに置換します。
 * @default OFF
 *
 * @param HyperLink
 * @desc
 * @default
 *
 * @param HyperLinkColor
 * @desc
 * @default
 *
 * @param param
 * @desc parameter
 * @default 1
 *
 * @help 
 *
 */
/*:ja
 * @plugindesc 他プラグイン書き換え用独自プラグイン
 * @author 白
 *
 *
 * @param 移動ルート置換
 * @desc （TemplateEvent.jsに機能追加）固有イベントに移動ルートが設定されていた場合でも、無視してテンプレートイベントの移動ルートに置換します。
 * @default OFF
 *
 * @param 強制移動ルート置換条件(移動タイプ)
 * @desc （TemplateEvent.jsに機能追加）移動ルート置換がOFFのとき、例外的にテンプレートイベントの移動ルートに置換する移動タイプ・移動条件の組み合わせを指定します。
 * @default 0
 
 * @param 強制移動ルート置換条件(移動速度)
 * @desc （TemplateEvent.jsに機能追加）移動ルート置換がOFFのとき、例外的にテンプレートイベントの移動ルートに置換する移動タイプ・移動条件の組み合わせを指定します。
 * @default 6
 *
 * @param ハイパーリンク
 * @desc （CustomizeErrorScreen.jsに機能追加）エラー画面に表示するリンク先URL
 * @default
 *
 * @param ハイパーリンク文字色
 * @desc （CustomizeErrorScreen.jsに機能追加）エラー画面に表示するリンク文字色
 * @default
 *
 * @param パラメータ
 * @desc 説明
 * @default 1
 * 
 * @help 
 *
 */
 
(function() {
    'use strict';
	var pluginName    = 'ESRT_Plugins_override';


    //=============================================================================
    // トリアコンタン様製プラグイン上書き用　
    //   トリアコンタン様のプラグインで宣言されているパラメータ取得用関数
    //=============================================================================
    var getParamNumber = function(paramNames, min, max) {
        var value = getParamOther(paramNames);
        if (arguments.length < 2) min = -Infinity;
        if (arguments.length < 3) max = Infinity;
        return (parseInt(value, 10) || 0).clamp(min, max);
    };

    var getParamString = function(paramNames) {
        var value = getParamOther(paramNames);
        return value === null ? '' : value;
    };
    
    var getParamBoolean = function(paramNames) {
        var value = getParamOther(paramNames);
        return (value || '').toUpperCase() === 'ON';
    };

    var getParamOther = function(paramNames) {
        if (!Array.isArray(paramNames)) paramNames = [paramNames];
        for (var i = 0; i < paramNames.length; i++) {
            var name = PluginManager.parameters(pluginName)[paramNames[i]];
            if (name) return name;
        }
        return null;
    };
    //=============================================================================
    // パラメータの取得と整形
    //=============================================================================
    var paramReplaceRoute          = getParamBoolean(['ReplaceRoute', '移動ルート置換']);
    var paramFoceReplaceRouteType  = getParamNumber(['paramFoceReplaceRouteType', '強制移動ルート置換条件(移動タイプ)']);
    var paramFoceReplaceRouteSpeed = getParamNumber(['paramFoceReplaceRouteSpeed', '強制移動ルート置換条件(移動速度)']);
    var paramHyperLink             = getParamString(['HyperLink', 'ハイパーリンク']);
    var paramHyperLinkColor        = getParamString(['HyperLinkColor', 'ハイパーリンク文字色']);
    
    //=============================================================================
    // PLUGIN OVERRIDE
    //  適用プラグインの処理を上書き・追加
    //=============================================================================
	// YEP_SelfSwVar.js
	// Set Event Location
	Yanfly.SSV.Game_Interpreter_command203 = Game_Interpreter.prototype.command203;
	Game_Interpreter.prototype.command203 = function() {
	  $gameTemp.setSelfSwVarEvent(this._mapId, this._eventId);
	  Yanfly.SSV.Game_Interpreter_command203.call(this);
	  $gameTemp.clearSelfSwVarEvent();
	  return true;
	};
	
	// YEP_SelfSwVar.js
	// Script
	Yanfly.SSV.Game_Interpreter_command355 = Game_Interpreter.prototype.command355;
	Game_Interpreter.prototype.command355 = function() {
	  $gameTemp.setSelfSwVarEvent(this._mapId, this._eventId);
	  Yanfly.SSV.Game_Interpreter_command355.call(this);
	  $gameTemp.clearSelfSwVarEvent();
	  return true;
	};
	
	// YEP_SelfSwVar.js
    // Plugin Command
	Yanfly.SSV.Game_Interpreter_command356 = Game_Interpreter.prototype.command356;
	Game_Interpreter.prototype.command356 = function() {
	  $gameTemp.setSelfSwVarEvent(this._mapId, this._eventId);
	  Yanfly.SSV.Game_Interpreter_command356.call(this);
	  $gameTemp.clearSelfSwVarEvent();
	  return true;
	};
    
    // PLUGIN OVERRIDE     TemplateEvent.js
    // 元ファイルにある関数を定義
    var getCommandName = function(command) {
        return (command || '').toUpperCase();
    };
    
    // 元ファイルにある関数を定義
     // convertEscapeCharactersを咬ませる処理を削除
      // argが0のとき、YEP_MessageCore.js:617のWindow_Message.Window_Base.setWordWrapにて引数のtextがundefinedとなるため
    var getArgNumber = function(arg, min, max) {
        if (arguments.length < 2) min = -Infinity;
        if (arguments.length < 3) max = Infinity;
        return (parseInt(arg, 10) || 0).clamp(min, max);
    };
    
    // 生成座標を変数から取得する機能を追加
    var _Game_Interpreter_pluginCommandEventReSpawn =Game_Interpreter.prototype.pluginCommandEventReSpawn;
    Game_Interpreter.prototype.pluginCommandEventReSpawn = function(command, args, extend) {
        _Game_Interpreter_pluginCommandEventReSpawn.apply(this, arguments);
        switch (getCommandName(command)) {
            case '生成_VAR' :
            case 'MAKE_VAR' :
                var x = getArgNumber($gameVariables.value(args[1]), 1);
                var y = getArgNumber($gameVariables.value(args[2]), 1);
                $gameMap.spawnEvent(this.getEventIdForEventReSpawn(args[0], extend), x, y, extend);
                break;
            case 'テンプレート生成_VAR' :
            case 'MAKE_TEMPLATE_VAR' :
                this.pluginCommandEventReSpawn('MAKE_VAR', args, true);
                break;
        }
    };
	
	// PLUGIN OVERRIDE     TemplateEvent.js
    var _Game_Event_setupPageSettings      = Game_Event.prototype.setupPageSettings;
    Game_Event.prototype.setupPageSettings = function() {
        _Game_Event_setupPageSettings.apply(this, arguments);
        
        var page  = this.getOriginalPages()[this._pageIndex];
        
        if (!paramReplaceRoute && page) {
            if (page.image && !this._originalEventId) { 
                // 呼び出し元に向き情報がある場合、その方向を向く。
                // ※ただし、EventReSpawn.jsで動的に生成した場合は元のイベント情報を向き情報含めてコピーするため、向きの再指定処理を除外する。
                this.setDirection(page.image.direction);
            }
            if(!(page.moveType == paramFoceReplaceRouteType && page.moveSpeed == paramFoceReplaceRouteSpeed)) {
    		    this._moveType = page.moveType;
                this._moveFrequency = page.moveFrequency;
                this._directionFix = page.directionFix;
    		    this.setMoveRoute(page.moveRoute);
            }
        }
    };
        
    //  PLUGIN OVERRIDE     CustomizeErrorScreen.js
    //  リンクの色を変更(視認性改善)
    Graphics._makeHyperLink = function() {
        var hyperLink            = document.createElement('a');
        var style                = hyperLink.style;
        style.color              = paramHyperLinkColor;
        style.textAlign          = 'left';
        style.fontSize           = '20px';
        style['text-decoration'] = 'underline';
        style.cursor             = 'pointer';
        hyperLink.addEventListener('click', this._openUrl.bind(this, paramHyperLink));
        hyperLink.innerHTML = paramHyperLink;
        this._errorPrinter.appendChild(hyperLink);
    };
    
    //  PLUGIN OVERRIDE     YEP_MessageCore.js
    var colorChangeList = [
                            {"name":"かな", "nameColorId":16, "outlineColorId":24},
                            {"name":"ポリン","nameColorId":17, "outlineColorId":25}
                        ];
    
    var _Window_Message_convertNameBox = Window_Message.prototype.convertNameBox;
    Window_Message.prototype.convertNameBox = function(text) {
        var textCopy = text;
        
        this._nameWindow._lastNameText = '';  // セリフの次の地の文まで縁取り色が引き継がれるのを回避
        text = _Window_Message_convertNameBox.apply(this, arguments);
        
        var re = /\x1bN\<(.*?)\>/i;
        if(re.test(textCopy)){
            this.changeOutlineColorForCharacter();
        }
        
        return text;
    };
    
    var _Window_Message_startMessage = Window_Message.prototype.startMessage;
    Window_Message.prototype.startMessage = function() {
        
        _Window_Message_startMessage.call(this);
        this.changeOutlineColorForCharacter();
    };
    
    // 文字の縁取りを喋っているキャラクターに応じて変更
    Window_Message.prototype.changeOutlineColorForCharacter = function() {
        for(var i=0; i < colorChangeList.length;i++){
            if((this._nameWindow.isOpen() || this._nameWindow.isOpening()) && this._nameWindow._lastNameText == colorChangeList[i].name){
                this.contents.outlineColor = this.textColor(colorChangeList[i].outlineColorId);
            }
        }
    }
    
    // 文字色を変えた時は縁取りを黒に、戻した時はキャラクターに応じた色に変更
    var _Window_Message_processEscapeCharacter = Window_Message.prototype.processEscapeCharacter;
    Window_Message.prototype.processEscapeCharacter = function(code, textState) {
        switch (code) {
        case 'C':
            var textStateCopy = {"index":textState.index,"text":textState.text};
            if(this.obtainEscapeParam(textStateCopy) > 0){
                this.contents.outlineColor = 'rgba(0, 0, 0, 0.5)';
            }else{
                this.changeOutlineColorForCharacter();
            }
            break;
        }
        _Window_Message_processEscapeCharacter.call(this, code, textState);
    };
    
    var Window_NameBox_drawTextEx = Window_NameBox.prototype.drawTextEx;
    Window_NameBox.prototype.drawTextEx = function(text, x, y) {
        for(var i=0; i < colorChangeList.length;i++){
            if(this._lastNameText == colorChangeList[i].name){
                this.changeTextColor(this.textColor(colorChangeList[i].outlineColorId));
                text = "\\c[" + colorChangeList[i].nameColorId + "]" + text;
            }
        }
        text = "\\c[6]" + text;
        
        return Window_NameBox_drawTextEx.call(this, text, x, y);
    };
    
    //  PLUGIN OVERRIDE     MPP_SimpleTouch3.js
    //　破壊的変更を一部のウィンドウではある程度元に戻す
    Window_Selectable.prototype.onTouchorig = function(triggered) {
        var lastIndex = this.index();
        var x = this.canvasToLocalX(TouchInput.x);
        var y = this.canvasToLocalY(TouchInput.y);
        var hitIndex = this.hitTest(x, y);
        if (ConfigManager.outsideTap === 1 && !this._notOutsideTap && // white_esorat独自追記。特定のWindowはウィンドウ外タップのキャンセル処理を除外（ウィンドウ外ボタン設置のため）
                !this._touchInsided && !this.isTouchedInsideFrame()) {
            if (this.isCancelEnabled())     this.processCancel();
            return;
        }
        if (hitIndex >= 0) {
            var symbol = this.commandSymbol(this.index());
            if (hitIndex === this.index() && !this.isVolumeSymbol(symbol) && !symbol.contains("Number")) { // white_esorat独自追記 ボリュームの操作はバーで行う
                if (triggered && this.isTouchOkEnabled()) {
                    this.processOk();
                }
            } else if (this.isCursorMovable()) {
                this.select(hitIndex);
            }
        } else if (this._stayCount >= 10) {
            if (y < this.padding) {
                this.cursorUp();
            } else if (y >= this.height - this.padding) {
                this.cursorDown();
            }
        }
        if (this.index() !== lastIndex) {
            SoundManager.playCursor();
        }
    };
    
    Window_Selectable.prototype.processTouchorig = function() {
        if (this.isOpenAndActive()) {
            if (TouchInput.isTriggered() && this.isTouchedInsideFrame()) {
                this._touching = true;
                this._selecting = true;
                this._touchCount = 0;
                this._touchX = TouchInput.x;
                this._touchY = TouchInput.y;
                this._touchInsided = this.isTouchedInsideFrame();
                this._originYSpeed = [];
                this.onTouch(true);
            } else if (TouchInput.isCancelled()) {
                if (this.isCancelEnabled()) {
                    this.processCancel();
                }
            }
            if (this._touching) {
                if (TouchInput.isPressed()) {
                    this.onTouch(false);
                } else {
                    this._touching = false;
                }
            }
        } else {
            this._touching = false;
        }
        
        if (this._canProcessTouchNonActive) {
            this.processTouchNonActive();
        }
    };
    //  PLUGIN OVERRIDE     MPP_SimpleTouch3.js
    // オプション画面ではスワイプで複数の項目を選択できるように(=バーを同時にいじれるように)
    Window_Options.prototype.onTouch = Window_Options.prototype.onTouchorig;
    Window_Options.prototype.processTouch = Window_Selectable.prototype.processTouchorig;
})();
