//=============================================================================
// ESRT_SceneGameEnd.js
// ----------------------------------------------------------------------------
// Copyright (c) 2017 @white_esorat
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// ----------------------------------------------------------------------------
// [HP]   : https://esora-t.jp/
// [Twitter]: https://twitter.com/white_esorat
//=============================================================================

/*:ja
 * @plugindesc ゲーム終了コマンド上書きプラグイン
 * @author 白
 * 
 * @help 
 * ゲーム終了コマンドから本当にゲームが終了できるようにします。
 *
 *
 */

(function() {
    'use strict';
	var pluginName    = 'ESRT_SceneTitle';
    
    //=============================================================================
    // パラメータの取得と整形
    //=============================================================================
    var parameters = PluginManager.parameters(pluginName);
    
    
    //=============================================================================
    // Scene_GameEnd
    //=============================================================================
    var _Scene_GameEnd_createCommandWindow      = Scene_GameEnd.prototype.createCommandWindow;
    Scene_GameEnd.prototype.createCommandWindow = function() {
        _Scene_GameEnd_createCommandWindow.apply(this, arguments);
        if(StorageManager.isLocalMode()) this._commandWindow.setHandler('windowClose', this.commandClose.bind(this));
    };
    
    Scene_GameEnd.prototype.commandClose = function() {
        window.close();
    };

    //=============================================================================
    // Window_GameEnd
    //=============================================================================
    Window_GameEnd.prototype.makeCommandList = function() {
        this.addCommand(TextManager.toTitle, 'toTitle');
        if(StorageManager.isLocalMode()) {
            this.addCommand("シャットダウン", 'windowClose');
        }
        this.addCommand(TextManager.cancel,  'cancel');
    };
})();
