//=============================================================================
// ESRT_SwVarOnChangeRestriction.js
// ----------------------------------------------------------------------------
// Copyright (c) 2017 @white_esorat
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// ----------------------------------------------------------------------------
// [HP]   : https://esora-t.jp/
// [Twitter]: https://twitter.com/white_esorat
// ----------------------------------------------------------------------------
//=============================================================================

/*:
 * @plugindesc Restricting Switches and Variables call onChange Function
 * @author white_esorat
 *
 * @help 
 *
 * This plugin does not provide plugin commands.
 * 
 * This plugin is released under the MIT License.
 *
 */
/*:ja
 * @plugindesc スイッチ・変数変更時の画面更新制限プラグイン
 * @author 白
 * 
 * @help 
 *
 * このプラグインには、プラグインコマンドはありません。
 * 
 * This plugin is released under the MIT License.
 *
 */
 
(function(){
    'use strict';
    
    //=============================================================================
    // Game_Switches
    //=============================================================================
    
    Game_Switches.prototype.setValue = function(switchId, value) {
        if (switchId > 0 && switchId < $dataSystem.switches.length) {
          var changeFlg = (this._data[switchId] != value) ? true : false;
          this._data[switchId] = value;
          if(changeFlg) this.onChange();
        }
    };
    
    //=============================================================================
    // Game_Variables
    //=============================================================================
    
    Game_Variables.prototype.setValue = function(variableId, value) {
        if (variableId > 0 && variableId < $dataSystem.variables.length) {
            if (typeof value === 'number') {
                value = Math.floor(value);
            }
            var changeFlg = (variableId, this._data[variableId] != value) ? true : false;
            this._data[variableId] = value;
            if(changeFlg) this.onChange();
        }
    };
    
    //=============================================================================
    // Game_SelfSwitches
    //=============================================================================
    
    Game_SelfSwitches.prototype.setValue = function(key, value) {
        if (value) {
            this._data[key] = true;
        } else {
            delete this._data[key];
        }
        this.onChange(key);
    };
    
    Game_SelfSwitches.prototype.onChange = function(key) {
        if($gameMap._events && $dataMap && $dataMap.events && key && $gameMap._events[key[1]]) {
            $gameMap._events[key[1]].refresh();
        }else{
            $gameMap.requestRefresh();
        }
    };
}());
