//=============================================================================
// ESRT_TitleLogo.js
// ----------------------------------------------------------------------------
// Copyright (c) 2018 @white_esorat
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// ----------------------------------------------------------------------------
// [HP]   : https://esora-t.jp/
// [Twitter]: https://twitter.com/white_esorat
//=============================================================================
/*:
 * @plugindesc タイトルロゴ表示用プラグイン
 * @author 白
 *
 * @help  
 *
 */

 var Esrt = Esrt || {};

 (function() {
     'use strict';
 	var pluginName    = 'ESRT_TitleLogo';

     //=============================================================================
     // パラメータの取得と整形
     //=============================================================================
     var parameters = PluginManager.parameters(pluginName);
     
     
     //=============================================================================
     // Game_Event
     //=============================================================================
     var _Scene_Title_initialize = Scene_Title.prototype.initialize;
     Scene_Title.prototype.initialize = function() {
        _Scene_Title_initialize.apply(this, arguments);
        
     	this._titleLogo = new Sprite(ImageManager.loadTitle1("title_logo"));
     	this._titleLogo.x = Graphics.boxWidth / 2;
     	this._titleLogo.y = Graphics.boxWidth / 8;
     	this._titleLogo.scale.x = 0.50;
     	this._titleLogo.scale.y = this._titleLogo.scale.x;
        this._titleLogo.anchor.x = 0.5
        this._titleLogo.anchor.y = 0.5
     	this._titleLogo.count = 0;
     	this.addChild(this._titleLogo);
     };
     
     var _Scene_Title_update = Scene_Title.prototype.update;
     Scene_Title.prototype.update = function() {
         _Scene_Title_update.call(this);
     	this.updateTitleLogo();
     };
     
     Scene_Title.prototype.updateTitleLogo = function() {
        if(typeof jQueryEasing === "undefined") return;
        var duration = 60;
        var baseScale    = (this._titleLogo.count < duration) ? jQueryEasing.easeOutBounce(this._titleLogo.count, 0, 1, duration) : 1;
        var baseRotation = (this._titleLogo.count < duration) ? jQueryEasing.easeOutBounce(this._titleLogo.count, 0, 1, duration) : 1;

     	this._titleLogo.scale.x = (Math.sin(this._titleLogo.count / 200) / 10 + baseScale) / 2;
     	this._titleLogo.scale.y = this._titleLogo.scale.x;
        this._titleLogo.count += 1;
        this._titleLogo.rotation = Math.sin(this._titleLogo.count / 50) / 10 + (baseRotation - 1);
     };
     
     

}());
